# piker: trading gear for hackers
# Copyright (C) Tyler Goodlet (in stewardship for pikers)

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.

# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

"""
daemon-service management API.

"""
from contextlib import (
    asynccontextmanager as acm,
)

import tractor
from tractor.hilevel import (
    ServiceMngr,
    # open_service_mngr as _open_service_mngr,
    get_service_mngr as get_service_mngr,
)
# TODO:
# -[ ] factor all the common shit from `.data._sampling`
#   and `.brokers._daemon` into here / `ServiceMngr`
#   in terms of allocating the `Portal` as part of the
#   "service-in-subactor" starting!
# -[ ] move to `tractor.hilevel._service`, import and use here!
# NOTE: purposely leaks the ref to the mod-scope Bo

Services: ServiceMngr|None = None

@acm
async def open_service_mngr(
    **kwargs,
) -> ServiceMngr:

    global Services
    async with tractor.hilevel.open_service_mngr(
        **kwargs,
    ) as mngr:
        # Services = proxy(mngr)
        Services = mngr
        yield mngr
        Services = None
